#!/bin/bash
#user: jinchuang

P="/usr/local/nginx/logs"
file="blog.access.log"
while true ;
do
echo "
1: 查询当天所有访问ip排行统计
2: 查询当天访问ip排行前20的统计
3: 查询当天访问最多ip所请求的页面统计
4: 查询指定时间段ip访问数量统计
5: 查询当天访问状态码统计
6: 查询访问状态码所请求的记录信息
0: 退出！
"
read -p "请输入编号：" a

case $a in

1)
cat $P/$file |awk '{print $1}' |sort -n  |uniq -c|sort -n
;;

2)
cat $P/$file |awk '{print $1}' |sort -n  |uniq -c|sort -n|tail -n 20
;;

3)
ip=`cat $P/$file |awk '{print $1}' |sort -n  |uniq -c|sort -n|tail -n 1 |awk '{print $2}'`
qd=`echo -e "\033[36m请求ip: \033[0m"`
sj=`echo -e "\033[36m请求时间: \033[0m"`
dz=`echo -e "\033[36m请求地址: \033[0m"`
zt=`echo -e "\033[36m状态码: \033[0m"`
awk -v wc="$ip" -v qiuip="$qd" -v shijian="$sj" -v dizhi="$dz" -v zhuang="$zt" '{if($1 == wc) print qiuip$1 "\t"   shijian$4 "\t  "    dizhi$7 "\t"zhuang$9}' $P/$file
;;

4)
read -p "请输入开始时间【如08:00输入0800】： " a
read -p "请输入结束时间【如12:00输入1200】： " b
cat $P/$file|awk -F "[-|:| ]+" -v k="$a" -v s="$b" '{if(s >= $3$4 && $3$4 >= k) print $0}' >/tmp/$a$b.log
cat /tmp/$a$b.log |awk '{print $1}' |sort -n  |uniq -c|sort -n
;;

5)
#赋值
zt=`echo -e "\033[36m状态码:\033[0m"`
er=`echo -e "\033[32m200\033[0m"`
sis=`echo -e "\033[33m403\033[0m"`
ss=`echo -e "\033[31m404\033[0m"`
wub=`echo -e "\033[31m500\033[0m"`
sly=`echo -e "\033[33m301\033[0m"`
sle=`echo -e "\033[33m302\033[0m"`
sals=`echo -e "\033[33m304\033[0m"`
#变量
ok=`awk '{print $9}' $P/$file |grep 200 |wc -l`
sls=`awk '{print $9}' $P/$file |grep 403 |wc -l`
slsi=`awk '{print $9}' $P/$file |grep 404 |wc -l`
wb=`awk '{print $9}' $P/$file |grep 500 |wc -l`
slyi=`awk '{print $9}' $P/$file |grep 301 |wc -l`
sler=`awk '{print $9}' $P/$file |grep 302 |wc -l`
ssi=`awk '{print $9}' $P/$file |grep 304 |wc -l`
#打印格式
printf "%-10s %-10s %-10s %-10s\n" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
printf "%-20s %-19s %-19s %-18s %-18s %-18s %-18s %-10s\n" $zt $er $sis $ss $wub $sly $sle $sals
printf "%-10s %-10s %-10s %-10s\n" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
printf "%-10s %-10s %-10s %-10s %-8s %-9s %-9s %-10s\n" 数量: $ok  $sls  $slsi  $wb $slyi $sler $ssi
printf "%-10s %-10s %-10s %-10s\n" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;;

6)
read -p "请输入要查询访问记录的状态码：" sta
cat $P/$file |awk -v jl=$sta '{if($9 == jl)print $0}'
;;

0)
exit
;;

*)
color=`echo -e "\033[36m！！请输入正确的编号！！ \033[0m"`
echo $color
;;
esac
done
